/// This file is inspired from gesture_x_detector.dart from the [gesture_x_detector](https://github.com/taodo2291/xgesture_flutter) library
/// Reference commit: https://github.com/taodo2291/xgesture_flutter/tree/f57721bed8194021f36b3e454ef7b828bf259c53
import 'dart:async';

import 'package:fast_immutable_collections/fast_immutable_collections.dart';
import 'package:flutter/gestures.dart';
import 'package:flutter/widgets.dart';


class a106 {
  
  final Offset a99;

  
  final Offset a98;

  
  final Offset a97;

  
  a106._a191(_a109 a502)
      : a99 = a502.a83,
        a98 = a502.a82 - a502.a83,
        a97 =
            a502.a81.getVelocityEstimate()?.pixelsPerSecond ??
                Offset.zero;
}

/// Signature for listening to tap events.
typedef TapEventListener = void Function(PointerEvent event);

/// Signature for listening to move events.
typedef MoveEventListener = void Function(a106 event);


class a107 extends StatefulWidget {
  
  const a107({
    Key? a503,
    required this.a96,
    this.a95,
    this.a94,
    this.a93,
    this.a92,
    this.a91,
    this.a90,
    this.a88 = kLongPressTimeout,
    this.a89 = kTouchSlop,
  }) : super(key: a503);

  
  final Widget a96;

  
  final TapEventListener? a95;

  
  final TapEventListener? a94;

  
  final Function()? a93;

  
  final MoveEventListener? a92;

  
  final MoveEventListener? a91;

  
  final MoveEventListener? a90;

  
  final double a89;

  
  final Duration a88;

  @override
  _a111 createState() => _a111();
}

enum _a108 {
  a87,
  a86,
  a85,
  a84,
}

@immutable
class _a109 {
  final Offset a83;
  final Offset a82;
  final VelocityTracker a81;

  Offset get a7 => a82 - a83;

  factory _a109.a192(PointerEvent a504) {
    return _a109._a193(
      a82: a504.localPosition,
      a83: a504.localPosition,
      a81: VelocityTracker.withKind(a504.kind)
        ..addPosition(a504.timeStamp, a504.position),
    );
  }

  const _a109._a193({
    required this.a82,
    required this.a83,
    required this.a81,
  });

  _a109 a32({
    Offset? a488,
    Offset? a489,
    VelocityTracker? a490,
  }) {
    return _a109._a193(
      a82: a489 ?? this.a82,
      a83: a488 ?? this.a83,
      a81: a490 ?? this.a81,
    );
  }
}

@immutable
class _a110 {
  final IMap<int, _a109> a80;
  final _a108 a79;

  const _a110({required this.a80, required this.a79});

  _a110 a31({
    IMap<int, _a109>? a486,
    _a108? a487,
  }) {
    return _a110(
      a80: a486 ?? this.a80,
      a79: a487 ?? this.a79,
    );
  }
}

class _a111 extends State<a107> {
  var _a301 = _a110(
    a80: IMap<int, _a109>(),
    a79: _a108.a84,
  );

  Timer? a78;

  @override
  Widget build(BuildContext context) {
    return Listener(
      behavior: HitTestBehavior.translucent,
      child: widget.a96,
      onPointerDown: _a194,
      onPointerUp: _a197,
      onPointerMove: _a195,
      onPointerCancel: _a198,
    );
  }

  @override
  void dispose() {
    _a202();
    super.dispose();
  }

  void _a194(PointerDownEvent a505) {
    final a302 = _a109.a192(a505);

    _a301 = _a301.a31(
      a486: _a301.a80.add(a505.pointer, a302),
    );

    if (_a209 == 1) {
      _a301 = _a301.a31(a487: _a108.a87);
      _a200(a505);
    } else {
      _a301 = _a301.a31(a487: _a108.a84);
    }
  }

  void _a195(PointerMoveEvent a506) {
    final a303 = _a301.a80[a506.pointer];

    if (a303 == null) return;

    final a304 = a303.a32(a489: a506.localPosition);

    if (!_a201(a304)) {
      _a202();
    }

    final a305 = () {
      switch (_a301.a79) {
        case _a108.a85:
          return a304.a32(
            a488: a304.a82,
          );

        case _a108.a87:
          return _a196(a304, a506);

        case _a108.a86:
          a304.a81.addPosition(
            a506.timeStamp,
            a506.position,
          );

          _a207(a304);

          return a304;

        default:
          return a304.a32(
            a488: a304.a82,
          );
      }
    }();

    _a301 = _a301.a31(
      a486: _a301.a80.add(a506.pointer, a305),
    );
  }

  _a109 _a196(_a109 a507, PointerMoveEvent a508) {
    final a306 = a507.a32(a489: a508.localPosition);

    if (!_a201(a306)) {
      _a301 = _a301.a31(a487: _a108.a86);
      _a206(a306);
    }

    return a306;
  }

  void _a197(PointerUpEvent a509) {
    final a307 = _a301.a80[a509.pointer];
    if (a307 == null) return;

    final a308 = a307.a32(a489: a509.position);

    _a301 = _a301.a31(
      a486: _a301.a80.add(a509.pointer, a308),
    );

    switch (_a301.a79) {
      case _a108.a87:
        _a203(a509.copyWith(position: a308.a83));
        break;

      case _a108.a86:
        a308.a81.addPosition(
          a509.timeStamp,
          a509.position,
        );

        _a208(a308);
        break;

      case _a108.a85:
        _a205();
        break;

      case _a108.a84:
        break;
    }

    _a301 = _a301.a31(a487: _a108.a84);

    _a199(a509.pointer);
  }

  void _a198(PointerCancelEvent a510) {
    _a199(a510.pointer);
  }

  void _a199(int a511) {
    _a301 = _a301.a31(
      a486: _a301.a80.remove(a511),
    );
  }

  void _a200(PointerEvent a512) {
    if (widget.a94 != null) {
      a78?.cancel();
      a78 = Timer(widget.a88, () {
        final a309 = _a301.a80[a512.pointer];

        if (_a209 == 1 && a309 != null) {
          _a301 = _a301.a31(a487: _a108.a85);
          _a204(a512);
          _a202();
        }
      });
    }
  }

  bool _a201(_a109 a513) {
    return a513.a7.distance.abs() <= widget.a89;
  }

  void _a202() {
    a78?.cancel();
    a78 = null;
  }

  void _a203(PointerEvent a514) {
    widget.a95?.call(a514);
  }

  void _a204(PointerEvent a515) {
    widget.a94?.call(a515);
  }

  void _a205() {
    widget.a93?.call();
  }

  void _a206(_a109 a516) {
    widget.a92?.call(a106._a191(a516));
  }

  void _a207(_a109 a517) {
    widget.a91?.call(a106._a191(a517));
  }

  void _a208(_a109 a518) {
    widget.a90?.call(a106._a191(a518));
  }

  get _a209 => _a301.a80.length;
}
