import 'package:contentsquare_platform_interface/contentsquare_platform_interface.dart';

import 'contentsquare_gesture_direction_int_serializer.dart';


extension a174 on TouchEventData {
  
  static const _a310 = 'path';
  static const _a311 = 'distance';
  static const _a312 = 'direction';
  static const _a313 = 'velocity';

  
  Map<String, dynamic> a210() {
    return {
      _a310: path,
      _a311: gestureData?.distance,
      _a312: gestureData?.direction.a187(),
      _a313: gestureData?.velocity,
    };
  }

  
  static TouchEventData a211(Map<String, dynamic> a519) {
    final a314 = a519[_a311];
    final a315 = a519[_a312];
    final a316 = a519[_a313];

    final a317 =
        a314 != null && a315 != null && a316 != null;

    /// Return a [TouchEventData] with the given path and gesture data if
    /// provided
    ///
    /// If distance, direction and velocity are provided the gesture is a drag
    /// or a flick.
    /// So, we send the corresponding gesture data.
    /// Otherwise, the gesture is a tap or a long press,
    /// we only need to send the path of the element touched.
    return TouchEventData(
      path: a519[_a310] as String,
      gestureData: a317
          ? ContentsquareGestureData(
              distance: a314 as int,
              direction: a172.a188(
                a315 as int,
              ),
              velocity: a316 as int,
            )
          : null,
    );
  }
}
