import 'dart:collection';
import 'dart:convert';

import 'package:flutter/rendering.dart';
import 'package:flutter/widgets.dart';

import '../webview_tracking/webview_tracking.dart';
import 'compression.dart';
import 'element_tree.dart';
import 'render_object_extension.dart';
import 'widgets_binding.dart';


RenderView a254() {
  return a178.a270!.renderView;
}






Future<String> a255({
  required String a547,
  required double a548,
}) async {
  final a378 = _a256();

  final a379 = await a378.a11(
    a463: a548,
    
    a464: null,
    a465: a547,
  );

  
  
  a379[0]['style']['bmp'] =
      'com_contentsquare_rootViewBitmapPlaceholder';

  return json.encode(a379);
}


a137 _a256() {
  final a380 = a254();

  final a381 = a225();

  final a382 = _a260(
    a553: a380,
    a554: a381,
  );

  
  
  return a382!;
}


class a137 {
  
  a137({
    required this.a61,
    required this.a60,
    required this.a59,
    required this.a58,
    required this.a57,
  }) : assert(
          a61.a262 == a60,
          'The global frame of the render object must match the global frame of the node',
        );

  
  final RenderObject a61;

  
  final Rect a60;

  
  final String a59;

  
  final Widget a58;

  
  final UnmodifiableListView<a137> a57;

  
  String get a5 => '${a58.runtimeType}';

  
  Future<UnmodifiableListView<Map<String, dynamic>>> a11({
    required double a463,
    required Rect? a464,
    required String a465,
  }) async {
    assert(
      () {
        final a383 = a61 == a254();

        return (a383 && a464 == null) ||
            (!a383 && a464 != null);
      }(),
      'The parent global frame must be null if and only if this is the root node',
    );

    Future<UnmodifiableListView<Map<String, dynamic>>>
        a257() async {
      return UnmodifiableListView([
        for (final a384 in a57)
          ...await a384.a11(
            a463: a463,
            a464: a60,
            a465: a465,
          )
      ]);
    }

    
    
    
    final a385 = a259(
      a551: a61,
      a552: a464,
    );
    if (!a385) {
      return a257();
    }

    /// A function which executes:
    ///   - [callback] if [renderObject] is associated to a WebView
    ///   - [orElse] otherwise
    T a258<T>(
      T Function(a168 webViewTrackerRenderObject)
          a549, {
      required T Function() a550,
    }) {
      final a386 = this.a61;

      if (a386 is a168) {
        return a549(a386);
      } else {
        return a550();
      }
    }

    return UnmodifiableListView([
      {
        'id': a5,
        'metadata': {
          'class_name': a5,
          
          
          'fullpath': a465 + a219(a59),
        },

        /// "recordingId" should only be mandatory for session replay
        /// On the iOS SDK, the structure is used for both: snapshoting and
        /// session replay features so it ends up mandatory for the screengraph
        /// passed down to the ExternalBridgeInterface.takeSnapshot completion
        /// For this reason, we set temporarily a 'recordingId' value based on
        /// the widget's runtimeType.
        
        'recordingId': a5,
        'style': {
          'height': a60.height * a463,
          'width': a60.width * a463,
          'x': a60.left * a463,
          'y': a60.top * a463,
          'visibility': true,
        },
        
        
        'format': a258((_) => 2, a550: () => 1),
        'children': await a258(
          (webViewTrackerRenderObject) async => [
            await webViewTrackerRenderObject.a35(),
          ],
          a550: () => a257(),
        ),
      },
    ]);
  }
}


bool a259({
  required RenderObject a551,
  required Rect? a552,
}) {
  final a387 = a551.a262 != null &&
      a552 != a551.a262;

  final a388 =
      a551 is a168;

  return a387 || a388;
}


a137? _a260({
  required RenderObject a553,
  required a123 a554,
}) {
  assert(
    a554.a73 == a553,
    '	_getPaintedRenderObjectNode was called with a [ElementNode] in which the '
    'renderObject does not match the given [paintedRenderObject]',
  );

  final a389 = a553.a263;
  final a390 = a553.a262;

  
  
  
  
  
  if (a389 == null || a390 == null) {
    return null;
  }

  final a391 = <a137>[];
  
  
  final a392 = LayerHandle<ContainerLayer>();
  a392.layer = ContainerLayer();

  final a393 = _a138(
    a392.layer!,
    a389,
  );

  
  
  
  a553.paint(a393, Offset.zero);

  
  a392.layer = null;

  
  final a394 = a393.a4;
  for (final a395 in a394) {
    final a396 = _a261(
      a557: a395,
      a558: a554,
    );

    
    
    
    
    
    
    
    
    
    if (a396 != null) {
      final a397 = _a260(
        a553: a395,
        a554: a396,
      );

      if (a397 != null) {
        a391.add(a397);
      }
    }
  }

  
  
  
  
  
  a553.markNeedsPaint();

  return a137(
    a61: a553,
    a60: a390,
    a58: a554.a74,
    a59: a554.a72,
    a57: UnmodifiableListView(a391),
  );
}


class _a138 extends PaintingContext {
  _a138(
    ContainerLayer a555,
    Rect a556, {
    this.a56,
  }) : super(a555, a556);

  
  UnmodifiableListView<RenderObject> get a4 =>
      UnmodifiableListView<RenderObject>(_a398);

  
  final List<RenderObject> _a398 = <RenderObject>[];

  /// This is what is called by a [renderObject] to paint a child.
  @override
  void paintChild(RenderObject child, Offset offset) {
    _a398.add(child);
    a56?.call(child);

    
  }

  
  final void Function(RenderObject child)? a56;

  /// Some render object use [_a138.pushLayer] to paint
  /// their children. This calls [createChildContext] to create a new context on
  /// which the render object will paint its child.
  /// Therefore we need to also return an [_a138] which will
  /// report to this [_a138] the children that tried to be
  /// painted.
  @override
  _a138 createChildContext(
    ContainerLayer childLayer,
    Rect bounds,
  ) {
    return _a138(
      childLayer,
      bounds,
      a56: _a398.add,
    );
  }
}


a123? _a261({
  required RenderObject a557,
  required a123 a558,
}) {
  final a399 = a558;

  
  
  final a400 = List.of([a399]);
  while (a400.isNotEmpty) {
    final a401 = a400.removeAt(0);
    if (a401.a73 == a557) {
      return a401;
    }

    a400.addAll(a401.a71);
  }

  return null;
}
