import 'dart:convert';

import 'package:contentsquare/contentsquare.dart';
import 'package:contentsquare/src/obfuscation/keep.dart';
import 'package:flutter/foundation.dart';

import 'adapters/adapters.dart';

/// The type of event that is sent from the webview.
@a453
enum ContentsquareJavascriptEventEnum {
  /// Send a pageView event or any kind of gesture.
  sendEvent,

  /// Send an exception.
  sendException,

  /// Send a message.
  sendMessage,

  /// Opt in.
  optIn,

  /// Opt out.
  optOut,

  /// Send transaction.
  sendTransaction,

  /// Send dynamic var.
  sendDynamicVar,
}


const _a430 =
    'CSJavascriptBridge_FlutterJavascriptChannel_';


@visibleForTesting
class a150 {
  
  a150({
    required this.a46,
    required this.a45,
    required this.a44,
  });

  
  final Contentsquare a46;

  
  final ContentsquareJavascriptEventEnum a45;

  
  String get _a271 =>
      '$_a430${a45.name}';

  
  final String? Function() a44;

  
  ContentsquareJavascriptChannel get a2 {
    return ContentsquareJavascriptChannel(
      name: _a271,
      onMessageReceived: (message) async {
        return _a272(message);
      },
    );
  }

  
  Future<void> _a272(String a566) {
    final a431 = jsonDecode(a566) as Map<String, dynamic>;
    return _a273(a46).a10(a431);
  }

  a139 _a273(Contentsquare a567) {
    switch (a45) {
      case ContentsquareJavascriptEventEnum.sendEvent:
        return a143(
          a52: a567,
          a51: a44,
        );
      case ContentsquareJavascriptEventEnum.sendException:
        return a144(a50: a567);
      case ContentsquareJavascriptEventEnum.sendMessage:
        return a145(a49: a567);
      case ContentsquareJavascriptEventEnum.optIn:
        return a140(a55: a567);
      case ContentsquareJavascriptEventEnum.optOut:
        return a141(a54: a567);
      case ContentsquareJavascriptEventEnum.sendTransaction:
        return a146(a48: a567);
      case ContentsquareJavascriptEventEnum.sendDynamicVar:
        return a142(a53: a567);
    }
  }

  
  String a9({
    required String Function(String channelName, String data)
        a454,
  }) =>
      '''
function (${_a273(a46).a3.map((name) => name).join(', ')}) {
  ${a454(_a271, 'JSON.stringify({${_a273(a46).a3.map((name) => '"$name": $name').join(', ')}})')};
}''';
}
