import 'package:contentsquare/src/modules/gestures/touch_event_data_json_serializer.dart';
import 'package:contentsquare_platform_interface/contentsquare_platform_interface.dart';
import 'package:flutter_test/flutter_test.dart';

void main() {
  group('TouchEventDataSerializer', () {
    group('toJson', () {
      test('should return a map of the formatted touch event data', () {
        expect(
            const TouchEventData(
              path: 'path/to/my/widget',
              gestureData: ContentsquareGestureData(
                distance: 42,
                direction: ContentsquareGestureDirection.left,
                velocity: 86,
              ),
            ).toJson(),
            {
              'path': 'path/to/my/widget',
              'distance': 42,
              'direction': 3,
              'velocity': 86,
            });
      });
    });

    group('fromJson', () {
      test('should return a $TouchEventData from a map', () {
        expect(
          TouchEventDataJsonSerializer.fromJson({
            'path': 'path/to/my/widget',
            'distance': 42,
            'direction': 3,
            'velocity': 86,
          }),
          const TouchEventData(
            path: 'path/to/my/widget',
            gestureData: ContentsquareGestureData(
              distance: 42,
              direction: ContentsquareGestureDirection.left,
              velocity: 86,
            ),
          ),
        );
      });
    });
  });
}
